> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.beehiiv.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.beehiiv.com/_mcp/server.

# List subscriptions <Badge intent="info" minimal outlined>OAuth Scope: subscriptions:read</Badge>

GET https://api.beehiiv.com/v2/publications/{publicationId}/subscriptions

Retrieve all subscriptions belonging to a specific publication. **New**: This endpoint now supports cursor-based pagination for better performance and consistency. Use the `cursor` parameter instead of `page` for new integrations.  **Deprecation Notice**: Offset-based pagination (using `page` parameter) is deprecated and limited to 100 pages maximum. Please migrate to cursor-based pagination. See our [Pagination Guide](/welcome/pagination) for details.

Reference: https://developers.beehiiv.com/api-reference/subscriptions/index

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `publicationId` (string, required) — The prefixed ID of the publication object

### Query parameters

- `expand[]` (enum, optional) — Optional list of expandable objects.`subscription_premium_tiers ` - Returns an array of tiers the subscription is associated with.`referrals` - Returns an array of subscriptions with limited data - `id`, `email`, and `status`. These are the subscriptions that were referred by this subscription.`stats` - Returns statistics about the subscription(s).`custom_fields` - Returns an array of custom field values that have been set on the subscription. `newsletter_lists` - Returns an array of newsletter list prefixed IDs the subscription is actively subscribed to.
  - Allowed values: `stats`, `custom_fields`, `referrals`, `newsletter_lists`
- `status` (enum, optional, default: all) — Optionally filter the results by a status
  - Allowed values: `validating`, `invalid`, `pending`, `active`, `inactive`, `all`
- `tier` (enum, optional, default: all) — Optionally filter the results by a their tier
  - Allowed values: `free`, `premium`, `all`
- `premium_tiers[]` (string, optional) — Optionally filter the results by one or multiple premium tiers
- `premium_tier_ids[]` (string, optional) — Optionally filter the results by one or multiple premium tier ids
- `limit` (integer, optional) — A limit on the number of objects to be returned. The limit can range between 1 and 100, and the default is 10.
- `cursor` (string, optional) — **Cursor-based pagination (recommended)**: Use this opaque cursor token to fetch the next page of results. When provided, pagination will use cursor-based method which is more efficient and consistent than offset-based pagination. See the [Pagination Guide](/welcome/pagination) for more details.
- `page` (integer, optional) — **Offset-based pagination (deprecated)**: Page number for offset-based pagination. This method is deprecated and limited to 100 pages maximum. Please migrate to cursor-based pagination using the `cursor` parameter. If not specified, results 1-10 from page 1 will be returned. See the [Pagination Guide](/welcome/pagination) for migration guidance.
- `email` (string, optional) — Optional email address to find a subscription.This param must be an exact match and is case insensitive.
- `order_by` (enum, optional, default: created) — The field that the results are sorted by. Defaults to created `created` - The time in which the subscription was first created.
  - Allowed values: `created`
- `direction` (enum, optional, default: asc) — The direction that the results are sorted in. Defaults to asc `asc` - Ascending, sorts from smallest to largest. `desc` - Descending, sorts from largest to smallest.
  - Allowed values: `asc`, `desc`
- `creation_date` (string, optional) — Optional date entry (in the format YYYY/MM/DD) that filters returned subscriptions by their creation date.

## Response

### 200

OK

- `data` (list of Subscription, required)
- `limit` (integer, optional) — The limit placed on the results. If no limit was specified in the request, this defaults to 10.
- `page` (integer, optional, default: 1) — **Offset pagination only**: The page number the results are from. Only present when using deprecated offset-based pagination.
- `total_pages` (integer, optional) — **Offset pagination only**: The total number of pages. Only present when using deprecated offset-based pagination.
- `has_more` (boolean, optional) — **Cursor pagination only**: Indicates whether there are more results available after the current page. Only present when using cursor-based pagination.
- `next_cursor` (string, optional) — **Cursor pagination only**: The cursor token to use for fetching the next page of results. This will be null if has_more is false. Only present when using cursor-based pagination.
- `total_results` (integer, optional) — **Mixed pagination**: The total number of results from all pages. For offset-based pagination, this is always included.

## Errors

### 400 Bad Request Error

Bad Request

- `status` (integer, required)
- `statusText` (string, required)
- `errors` (list of ErrorDetail, required)

### 401 Unauthorized Error

Unauthorized. The API key or OAuth access token is missing, invalid, or expired.

- `status` (integer, required)
- `statusText` (string, required)
- `errors` (list of ErrorDetail, required)

### 404 Not Found Error

Resource Not Found

- `status` (integer, required)
- `statusText` (string, required)
- `errors` (list of ErrorDetail, required)

### 429 Too Many Requests Error

Rate Limit Exceeded

- `status` (integer, required)
- `statusText` (string, required)
- `errors` (list of ErrorDetail, required)

### 500 Internal Server Error

Internal Server Error

- `status` (integer, required)
- `statusText` (string, required)
- `errors` (list of ErrorDetail, required)

## Types

### Subscription

The subscription object

- `id` (string, required) — The prefixed subscription id
- `email` (string, required)
- `status` (enum, required) — The status of the subscription.`validating` - The email address is being validated.`invalid` - The email address is invalid.`pending` - The email address is valid, but the subscription is pending double opt-in.`active` - The email was valid and the subscription is active.`inactive` - The subscription was made inactive, possibly due to an unsubscribe.`needs_attention` - The subscription requires approval or denial.
  - Allowed values: `validating`, `invalid`, `pending`, `active`, `inactive`, `needs_attention`, `paused`
- `created` (integer, required) — The date the subscription was created. Measured in seconds since the Unix epoch
- `subscription_tier` (enum, required) — The current tier of the subscription.
  - Allowed values: `free`, `premium`
- `subscription_premium_tier_names` (list of string, required) — The current premium tiers of the subscription. Empty if the subscriber is not associated with any premium tiers.
- `utm_source` (string, required) — The acquisition source; where the subscriber came from
- `utm_medium` (string, required) — The acquisition medium; how the subscriber got to your publication
- `utm_channel` (enum, required) — The acquisition channel
  - Allowed values: ``, `website`, `import`, `embed`, `api`, `referral`, `recommendation`, `magic_link`, `boost`, `boost_send`, `boost_direct_link`, `integration`, `product`, `group_invite`
- `utm_campaign` (string, required) — The acquisition campaign
- `utm_term` (string, required) — The acquisition term; typically the keyword or search term
- `utm_content` (string, required) — The acquisition content; typically used for A/B testing or ad variations
- `referring_site` (string, required) — The website that the subscriber was referred from
- `referral_code` (string, required) — The code associated to this subscriber to refer others. When a new subscription is created with this referral code, credit for the referral goes to this subscription.
- `subscription_premium_tiers` (list of SubscriptionTierInfo, optional) — Optional list of tiers for a subscription. Retrievable by including `expand: [subscription_premium_tiers]` in the request body.
- `custom_fields` (list of CustomField, optional) — Optional list of custom fields for a subscription. Retrievable by including `expand: [custom_field]` in the request body.
- `tags` (list of string, optional) — Optional list of tags for a subscription. Retrievable by including `expand: [tags]` in the request body. Max limit of 100 unique tags per publication.
- `stats` (SubscriptionStats, optional) — Optional list of stats for a subscription. Retrievable by including `expand: [stats]` in the request body.
- `newsletter_list_ids` (list of string, optional) — The prefixed IDs of the newsletter lists this subscription is actively subscribed to. Requires `expand[]=newsletter_lists`.

### ErrorDetail

- `message` (string, required)
- `code` (string, required)

### SubscriptionTierInfo

- `id` (string, required) — The prefixed ID of the tier.
- `name` (string, required)
- `status` (enum, required) — Returns whether or not the tier has any active prices.
  - Allowed values: `active`, `archived`

### CustomField

- `name` (string, optional) — The name of the existing custom field
- `kind` (enum, optional) — The type of value being stored in the custom field.
  - Allowed values: `string`, `integer`, `boolean`, `date`, `datetime`, `list`, `double`
- `value` (CustomFieldDataType, optional) — The value stored for the subscription

### SubscriptionStats

Optional list of stats for a subscription. Retrievable by including `expand: [stats]` in the request body.

- `emails_received` (integer, optional) — The total number of emails that have been sent to this subscriber
- `open_rate` (double, optional) — The percentage of emails that the subscriber has opened
- `click_through_rate` (double, optional) — The percentage of emails that the subscriber has clicked a link in

### CustomFieldDataType

## Examples

### Cursor-based pagination (recommended)

**Response**

```json
{
  "data": [
    {
      "id": "sub_00000000-0000-0000-0000-000000000000",
      "email": "example@example.com",
      "status": "validating",
      "created": 1666800076,
      "subscription_tier": "free",
      "subscription_premium_tier_names": [
        "Premium",
        "Gold"
      ],
      "utm_source": "Twitter",
      "utm_medium": "organic",
      "utm_channel": "website",
      "utm_campaign": "utm_campaign",
      "utm_term": "",
      "utm_content": "",
      "referring_site": "https://www.blog.com",
      "referral_code": "referral_code",
      "subscription_premium_tiers": [
        {
          "id": "tier_00000000-0000-0000-0000-000000000000",
          "name": "name",
          "status": "active"
        }
      ],
      "custom_fields": [
        {}
      ],
      "tags": [
        "Premium",
        "Basic",
        "Active",
        "Engaged"
      ],
      "stats": {
        "emails_received": 25,
        "open_rate": 60.1,
        "click_through_rate": 25
      }
    }
  ],
  "limit": 10,
  "has_more": true,
  "next_cursor": "eyJ0aW1lc3RhbXAiOiIyMDI0LTA3LTAyVDE3OjMwOjAwLjAwMDAwMFoifQ=="
}
```

**SDK Code**

```typescript Cursor-based pagination (recommended)
import { BeehiivClient } from "beehiiv";

const client = new BeehiivClient({ token: "YOUR_TOKEN" });
await client.subscriptions.list("pub_00000000-0000-0000-0000-000000000000", {
    email: "clark@dailyplanet.com"
});

```

```python Cursor-based pagination (recommended)
import requests

url = "https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/subscriptions"

querystring = {"limit":"10"}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```go Cursor-based pagination (recommended)
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/subscriptions?limit=10"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Cursor-based pagination (recommended)
require 'uri'
require 'net/http'

url = URI("https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/subscriptions?limit=10")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java Cursor-based pagination (recommended)
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/subscriptions?limit=10")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php Cursor-based pagination (recommended)
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/subscriptions?limit=10', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp Cursor-based pagination (recommended)
using RestSharp;

var client = new RestClient("https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/subscriptions?limit=10");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift Cursor-based pagination (recommended)
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/subscriptions?limit=10")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### Cursor-based pagination (next page)

**Response**

```json
{
  "data": [
    {
      "id": "sub_11111111-1111-1111-1111-111111111111",
      "email": "next@example.com",
      "status": "active",
      "created": 1666800000,
      "subscription_tier": "premium",
      "subscription_premium_tier_names": [
        "Premium"
      ],
      "utm_source": "Direct",
      "utm_medium": "email",
      "utm_channel": "website",
      "utm_campaign": "welcome_series",
      "utm_term": "",
      "utm_content": "",
      "referring_site": "https://www.example.com",
      "referral_code": "WELCOME2024",
      "subscription_premium_tiers": [
        {
          "id": "tier_11111111-1111-1111-1111-111111111111",
          "name": "Premium",
          "status": "active"
        }
      ],
      "custom_fields": [
        {}
      ],
      "tags": [
        "Premium",
        "New"
      ],
      "stats": {
        "emails_received": 15,
        "open_rate": 45.2,
        "click_through_rate": 18.5
      }
    }
  ],
  "limit": 10,
  "has_more": false,
  "next_cursor": null
}
```

**SDK Code**

```typescript Cursor-based pagination (next page)
import { BeehiivClient } from "beehiiv";

const client = new BeehiivClient({ token: "YOUR_TOKEN" });
await client.subscriptions.list("pub_00000000-0000-0000-0000-000000000000", {
    email: "clark@dailyplanet.com"
});

```

```python Cursor-based pagination (next page)
import requests

url = "https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/subscriptions"

querystring = {"limit":"10","cursor":"eyJ0aW1lc3RhbXAiOiIyMDI0LTA3LTAyVDE3OjMwOjAwLjAwMDAwMFoifQ=="}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```go Cursor-based pagination (next page)
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/subscriptions?limit=10&cursor=eyJ0aW1lc3RhbXAiOiIyMDI0LTA3LTAyVDE3OjMwOjAwLjAwMDAwMFoifQ%3D%3D"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Cursor-based pagination (next page)
require 'uri'
require 'net/http'

url = URI("https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/subscriptions?limit=10&cursor=eyJ0aW1lc3RhbXAiOiIyMDI0LTA3LTAyVDE3OjMwOjAwLjAwMDAwMFoifQ%3D%3D")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java Cursor-based pagination (next page)
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/subscriptions?limit=10&cursor=eyJ0aW1lc3RhbXAiOiIyMDI0LTA3LTAyVDE3OjMwOjAwLjAwMDAwMFoifQ%3D%3D")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php Cursor-based pagination (next page)
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/subscriptions?limit=10&cursor=eyJ0aW1lc3RhbXAiOiIyMDI0LTA3LTAyVDE3OjMwOjAwLjAwMDAwMFoifQ%3D%3D', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp Cursor-based pagination (next page)
using RestSharp;

var client = new RestClient("https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/subscriptions?limit=10&cursor=eyJ0aW1lc3RhbXAiOiIyMDI0LTA3LTAyVDE3OjMwOjAwLjAwMDAwMFoifQ%3D%3D");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift Cursor-based pagination (next page)
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/subscriptions?limit=10&cursor=eyJ0aW1lc3RhbXAiOiIyMDI0LTA3LTAyVDE3OjMwOjAwLjAwMDAwMFoifQ%3D%3D")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### Offset-based pagination (deprecated)

**Response**

```json
{
  "data": [
    {
      "id": "sub_00000000-0000-0000-0000-000000000000",
      "email": "example@example.com",
      "status": "validating",
      "created": 1666800076,
      "subscription_tier": "free",
      "subscription_premium_tier_names": [
        "Premium",
        "Gold"
      ],
      "utm_source": "Twitter",
      "utm_medium": "organic",
      "utm_channel": "website",
      "utm_campaign": "utm_campaign",
      "utm_term": "",
      "utm_content": "",
      "referring_site": "https://www.blog.com",
      "referral_code": "referral_code",
      "subscription_premium_tiers": [
        {
          "id": "tier_00000000-0000-0000-0000-000000000000",
          "name": "name",
          "status": "active"
        }
      ],
      "custom_fields": [
        {}
      ],
      "tags": [
        "Premium",
        "Basic",
        "Active",
        "Engaged"
      ],
      "stats": {
        "emails_received": 25,
        "open_rate": 60.1,
        "click_through_rate": 25
      }
    }
  ],
  "limit": 10,
  "page": 1,
  "total_pages": 150,
  "total_results": 1500
}
```

**SDK Code**

```typescript Offset-based pagination (deprecated)
import { BeehiivClient } from "beehiiv";

const client = new BeehiivClient({ token: "YOUR_TOKEN" });
await client.subscriptions.list("pub_00000000-0000-0000-0000-000000000000", {
    email: "clark@dailyplanet.com"
});

```

```python Offset-based pagination (deprecated)
import requests

url = "https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/subscriptions"

querystring = {"email":"clark@dailyplanet.com","page":"1","limit":"10"}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```go Offset-based pagination (deprecated)
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/subscriptions?email=clark%40dailyplanet.com&page=1&limit=10"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Offset-based pagination (deprecated)
require 'uri'
require 'net/http'

url = URI("https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/subscriptions?email=clark%40dailyplanet.com&page=1&limit=10")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java Offset-based pagination (deprecated)
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/subscriptions?email=clark%40dailyplanet.com&page=1&limit=10")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php Offset-based pagination (deprecated)
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/subscriptions?email=clark%40dailyplanet.com&page=1&limit=10', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp Offset-based pagination (deprecated)
using RestSharp;

var client = new RestClient("https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/subscriptions?email=clark%40dailyplanet.com&page=1&limit=10");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift Offset-based pagination (deprecated)
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/subscriptions?email=clark%40dailyplanet.com&page=1&limit=10")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```